function complementCodedData=ART_Complement_Code(data)

%Complements data, for data =   0.3 0.2 0.6
%                               0.4 0.1 0.8
% gives                             same
%                               0.7 0.8 0.4
%                                   same
%                               0.6 0.9 0.2

%The complement coding works on each column, i.e. each sample
%DATA is a matrix of size NumFeatures-by-NumSamples

%Determines the size of the data
[numFeatures,numSamples]=size(Data);

%Creates a return variable

complementCodedData=ones(2*numFeatures, numSamples);

%Complement codes for each sample

for j=1:numSamples
    count=1;
    for i=1:2:(2*numFeatures)
        complementCodedData(i,j)=data(count,j);
        complementCodedData(i+1,j)=1 - data(count,j);
        count=count+1;
    end
end

return
        
        