
Pr=(1:6)*1E6;
Ts=0.9*1e-6;
Fp=exp(-Pr*Ts);
Real=Pr'*Fp;
cor=diag(Real);
figure(1);
plot(Pr,cor,'b*');
title('Figure');
xlabel('arrival rate [pulses /sec]');
ylabel('number of processed pulses');

text(40E5,200000,'Ts =0.9e-6','FontSize',18);
%xlswrite('Ts1e-6',Pr',1,'A2');
%xlswrite('Ts1e-6',cor,1,'B2');

bitvec=zeros(3,(300-29));
tel=1;
bitlen=(30:300);
for j=30:300;
    bitvec(1,j)=j*[55544.98269121153];
    bitvec(2,j)=j*[33689.73];
    bitvec(3,j)=j*[222.9];
end
figure(2);
plot(bitlen,log(bitvec(1,30:300)),'b-');
hold on;
plot(bitlen,log(bitvec(2,30:300)),'g:')
plot(bitlen,log(bitvec(3,30:300)),'r-.');
text(180,14,'blue whole(Ts=0.9e-6)','FontSize',12);
text(180,13,'green dash(Ts=1e-6)','FontSize',12);
text(180,12,'red dash dot(Ts=2.0e-6)','FontSize',12);
title('Figure');
xlabel('number of bits in PDW');
ylabel('relative difference in bit flow from receiver [log]');