v1=zeros(1,3000);


for h=1:8:3000,
   v1(h)=h;
end

for g=1:5:3000,
    if v1(g) == 0,
    v1(g)=g;
    else v1(g)~=0
        if v1(g)<g,
            v1(g+1)=g;
        elseif v1(g)>g,
            v1(g-1)=g;
        else
            v1(g)=g;
        end
    end
end
for l=1:11:3000,
    if v1(l) == 0,
        v1(l)=l;
    else v1(l)~=0
        if v1(l)<l,
            v1(l+1)=l;
        elseif v1(l)>l,
            v1(l-1)=l;
        else
            v1(l)=l;
        end
    end
end
v_mel=sort(v1);

for d=1:length(v_mel)
    if v_mel(d)==0,
        mar=d;
    else
        v_ny(d-mar+1)=v_mel(d);
    end
end

%%Vector DIFFS.FIRST stores the differences between every adjacent pulse
for tel1=1:length(v_ny)-1;
    diffs.first(tel1)=v_ny(tel1+1)-v_ny(tel1);
end

%%Vector DIFFS.SECOND stores the differences between every adjacent pulse
%%but one
for tel2=1:length(v_ny)-2,
    diffs.second(tel2)=v_ny(tel2+2)-v_ny(tel2);
end

%%Vector DIFFS.THIRD stores the differences between every adjacent pulse
%%but two
for tel3= 1:length(v_ny)-3,
    diffs.third(tel3)=v_ny(tel3+3)-v_ny(tel3);
end

%%Vector DIFFS.fourth stores the differences between every adjacent pulse
%%but three
for tel4= 1:length(v_ny)-4,
    diffs.fourth(tel4)=v_ny(tel4+4)-v_ny(tel4);
end

%%The following code determines the threshold function for the given
%%difference level, based on equation 1.8. c defines the difference level,
%%k and x is constants determined experimentally, and N is the number of
%%bins in the histogram

E=length(v_ny);
c=1;
k1=0.8;
x1=0.6;
N=(5:5:20);
for tau=0:2996-1,
    Tres1(tau+1)=x1*(E-c)*exp(-tau/(k1*N(1)));% E er # pulser,N er # bins,c er diff
end

k2=0.8;
x2=0.6;
c2=2;
for tau2=0:2996-1,
    Tres2(tau2+1)=x2*(E-c2)*exp(-tau2/(k2*N(2)));% E er # pulser,N er # bins,c er diff
end

k3=0.99;
x3=0.6;
c3=3;
for tau3=0:2996-1,
    Tres3(tau3+1)=x3*(E-c3)*exp(-tau3/(k3*N(3)));% E er # pulser,N er # bins,c er diff
end


k4=0.99;
x4=0.7;
c4=4;
for tau4=0:2996-1,
    Tres4(tau4+1)=x4*(E-c4)*exp(-tau4/(k4*N(4)));% E er # pulser,N er # bins,c er diff
end

L1=diffs.first;
L2=diffs.second;
L3=diffs.third;
L4=diffs.fourth;

L_1=length(diffs.first);
L_2=length(diffs.second);
L_3=length(diffs.third);
L_4=length(diffs.fourth);

%%The code merges the differences from the first and second difference
%%vectors to one vector
tot2dif=zeros(1,L_1 + L_2);
L2_t=length(tot2dif);

for count=1:L2_t,
    if count <=L_1,
        tot2dif(count)= L1(count);
    else
        tot2dif(count)= L2(count-L_1);
    end
end

%%The code merges the differences from the first, second, and third difference
%%vectors to one vector


tot3dif=zeros(1,(L_1 + L_2 + L_3)-2);
L3_t=length(tot3dif);

for count2=1:L3_t,
    if count2 <=L_1,
        tot3dif(count2)= L1(count2);
    elseif count2 >L_1 && count2 <= (L_1+L_2),
        tot3dif(count2)= L2(count2-L_1);
    else
        tot3dif(count2)= L3(count2-(L_1+L_2));
  
        
    end
end

tot4dif=zeros(1,(L_1+L_2+L_3+L_4)-3);
L4_t=length(tot4dif);

for count3=1:L4_t,
    if count3<=L_1,
        tot4dif(count3)=L1(count3);
    elseif count3 > L_1 && count3 <= (L_1+L_2),
        tot4dif(count3)= L2(count3-L_1);
    elseif count3 >(L_1+L_2) && count3 <= (L_1+L_2+L_3),
        tot4dif(count3)=L3(count3-(L_1+L_2));
    else
        tot4dif(count3)=L4(count3-(L_1+L_2+L_3));
    end
end
%%The parameter PARA represents the x ni the initial threshold function, as
%%given in equation 1.7
para=0.9;

figure(1);
edges=(1:5);
n= histc(diffs.first,edges);
bar(n,'r');
hold on;
T1=para*L_1*(1./edges);
plot(T1,'k:');
plot(Tres1,'b');
axis([0 10 0 600]);
title('SIM D; CDIF, 1. diff');
xlabel('delta time');
ylabel('# pulses');

figure(2);
edges2=(1:10);
n2=histc(tot2dif,edges2);
bar(n2,'r');
hold on;
T2=para*L_2*(1./edges2);
plot(T2,'k:');
plot(Tres2,'b');
axis([0 12 0 600]);
title('SIM D; CDIF, 2. diff');
xlabel('delta time');
ylabel('# pulses');

figure(3);
edges3=(1:15);
n3=histc(tot3dif,edges3);
bar(n3,'r');
hold on;
T3=para*L_3*(1./edges3);
plot(T3,'k:');
plot(Tres3,'b');
axis([0 15 0 700]);
title('SIM D; CDIF, 3. diff');
xlabel('delta time');
ylabel('# pulses');


figure(4);
edges4=(1:20);
n4=histc(tot4dif,edges4);
bar(n4,'r');
hold on;
T4=para*L_4*(1./edges4);
plot(T4,'k:');
plot(Tres4,'b');
axis([0 20 0 700]);
title('SIM D; CDIF, 4. diff');
xlabel('delta time');
ylabel('# pulses');
